<?php
namespace Mince;

use Index\Environment;
use Index\XString;
use Index\Data\ConnectionFailedException;
use Index\Data\DbTools;

define('MCR_STARTUP', microtime(true));
define('MCR_ROOT', __DIR__);
define('MCR_DEBUG', is_file(MCR_ROOT . '/.debug'));
define('MCR_DIR_SRC', MCR_ROOT . '/src');
define('MCR_DIR_PUB', MCR_ROOT . '/public');
define('MCR_DIR_PRV', MCR_ROOT . '/private');
define('MCR_DIR_CFG', MCR_ROOT . '/config');
define('MCR_DIR_MIG', MCR_ROOT . '/database');

require_once MCR_ROOT . '/vendor/autoload.php';

Environment::setDebug(MCR_DEBUG);

$config = parse_ini_file(MCR_DIR_CFG . '/config.ini');
if($config === false)
    die('Config sux.');

try {
    $db = DbTools::create($config['dsn']);
} catch(ConnectionFailedException $ex) {
    echo '<h3>Unable to connect to database</h3>';
    die($ex->getMessage());
}

$remote = new RemoteV2($config['remotev2_url'], $config['remotev2_secret']);

if(PHP_SAPI !== 'cli') {
    if(empty($_COOKIE['mc_random'])) {
        $sVerification = XString::random(32);
        setcookie('mc_random', $sVerification, strtotime('1 day'), '/', $_SERVER['HTTP_HOST']);
    } else
        $sVerification = (string)filter_input(INPUT_COOKIE, 'mc_random');

    $sVerification = hash('sha256', $sVerification);

    // replace this with id.flashii.net shit
    $userInfo = ChatAuth::attempt($db, $config['chat_endpoint'], $config['chat_secret'], (string)filter_input(INPUT_COOKIE, 'msz_auth'));
}
